//-------------------------------------------------------------------------
// (c) ColoneL 1996-2001
//-------------------------------------------------------------------------
//        Delphi
//  - 20.08.2001  function GetFDateTime
//  - 07.06.2001  function SubTick
//  - 18.05.2001  function GetFSize
//  - 16.05.2001  function RepChar, f2s, s2f
//  - 11.01.2001  function iLine, iRectangle, iBox, iFillBox
//  - 19.12.2000  function FullTrim, Translit
//  - 14.12.2000  function LoadStringFromFile, SaveStringToFile, ConvertStringToChars, SaveConvStringToFile
//  - 31.05.2000  function ShiftColorPalette.
//  - 07.04.2000  function i2b,b2i,b2i64,i2s,s2i,s2i64;
//  - 17.03.2000  function Int64ToBin ( i2b), BinToInt64 ( b2i).
//  - 14.10.1999 ( TBitmap.Scanline     BGRx,   RGBx);
//                function Color2BGR, BGR2Color.
//                type     TIntArray, PIntArray.
//  - 13.10.1999  function BrightColor, MixGlassColors.
//  - 12.10.1999  function MixColors, SumColors.
//  - 11.10.1999  function GetColorFromList.
//  - 08.10.1999  type     TRGB, TiRGB.
//                function Color2RGB, RGB2Color, FadeColor, GetMidColor.
//  (c) by ColoneL 1995-2000
//----------------------------------------------------------------------------

unit colonel_Utility;

interface
uses Printers, windows, Classes, SysUtils, IniFiles, Forms,
     dialogs, graphics, extctrls, controls;

const
  bit0  = $00000001;
  bit1  = $00000002;
  bit2  = $00000004;
  bit3  = $00000008;
  bit4  = $00000010;
  bit5  = $00000020;
  bit6  = $00000040;
  bit7  = $00000080;

  zbit0 = ($FFFFFFFF xor bit0);
  zbit1 = ($FFFFFFFF xor bit1);
  zbit2 = ($FFFFFFFF xor bit2);
  zbit3 = ($FFFFFFFF xor bit3);
  zbit4 = ($FFFFFFFF xor bit4);
  zbit5 = ($FFFFFFFF xor bit5);
  zbit6 = ($FFFFFFFF xor bit6);
  zbit7 = ($FFFFFFFF xor bit7);

   translitRus = '                                                                             ';
   translitLat = 'A B V G D E E Zh Z I Y K L M N O P R S T U F H C Ch Sh Sh '' Y '' E Yu Ya a b v g d e e zh z i y k l m n o p r s t u f h c ch sh sh '' y '' e yu ya';

      //       GetDirsList  GetFilesList
   constNoSort = false;
   constSort   = true;
     // ,     TDateTim'
   dtSecond = 1/(24*60*60);
   dtMinute = 1/(24*60);
   dtHour   = 1/(24);


type
  TColorArray = array of TColor;

  PPointer = ^Pointer;

  TNilClass = class
    objInstancePrt : PPointer;
    constructor Create (NewInstanceAddress:pointer);
    destructor  destroy; override;
  end;

  TArrayOfChar = Array of char;
  PArrayOfChar = ^TArrayOfChar;

  TArrayOfInteger = array of integer;
  PArrayOfInteger = ^TArrayOfInteger;

  TArrayOfPointer = array of Pointer;
  PArrayOfPointer = ^TArrayOfPointer;

  TIntArray = array [0..32767] of Integer;
  PIntArray = ^TIntArray;

  TBitmapLinesArray = array of PIntArray;

  TBitmapLinesRecord = record
    height : integer;
    width  : integer;
    lines  : TBitmapLinesArray;
  end;
  PBitmapLinesRecord = ^TBitmapLinesRecord;

  TRGB = packed record
    case integer of
      0 :  (red   : byte;
            green : byte;
            blue  : byte;
            nu    : byte);
      1 : (color : TColor);
  end;

  TIRGB = packed record
    ired   : integer;
    igreen : integer;
    iblue  : integer;
  end;

  TInt64Byte = packed record
    case integer of
      0: (int:int64);
      1: (LoDWord,HiDWord : DWord);
      2: (LoLoWord,LoHiWord,HiLoWord,HiHiWord : Word);
      3: (bytes: array [0..7] of byte);
  end;

  TInt32Byte = packed record
    case integer of
      0: (int:longint);
      1: (LoWord,HiWord : Word);
      2: (bytes: array [0..3] of byte);
  end;


var
    PrinterResX, PrinterResY : integer; {  : Pixels Per Inch }
    PrinterAspectRatio       : real;    {  : X/Y }
    PrinterPageHeight        : real;    {    mm }
    PrinterPageWidth         : real;    {    mm }
    PrinterHeader            : real;    { ,   Header & Footer}
    PrinterFooter            : real;

  {    ( windows 95,98.  NT  ) }
function  PortIn   (IOport:word):byte;
function  PortInW  (IOport:word):word;
procedure PortOut  (IOport:word; Value:byte);
procedure PortOutW (IOport:word; Value:word);

  {   }
  {    chrWhat   }
FUNCTION DelChar (chrWhat:char; strString:string):string;
  {    chrWhat,  chrTo }
FUNCTION RepChar (chrWhat,chrTo:char; strString:string):string;
  {   strString   chrWhat   NewLength }
FUNCTION AddLeft (chrWhat:char; NewLength:integer; strString:string):string;
  {   strString   chrWhat   NewLength }
FUNCTION AddRight (chrWhat:char; NewLength:integer;strString:string):string;
  {        }
FUNCTION DelNonDigit (strString:string):string;
FUNCTION DelNonHEX (strString:string):string;
FUNCTION DelNonAlphaChar (strString:string):string;
  {        }
function FullTrim (str:string):string;
function Translit (str:string):string;
  {     YYMMDD  DDMMYY   }
FUNCTION ReverseDate (strDate:string):string;
  {     XXYYZZ  XX.YY.ZZ }
FUNCTION ExDate (strDate:string):string;
  {     HHMMSS  HH:MM.SS }
FUNCTION ExTime (strTime:string):string;
  {     HHMMSS ( HHMM)  HH:MM }
FUNCTION ExTimeShort (strTime:string):string;
  {       Time1-Time2}
Function SubTime (Time1,Time2:TDateTime):double;
  {    ,     49  } 
function SubTick (oldTick:DWord):DWord;
  {  DateTime   }
Function DateTimeToSec (dt:TDateTime):extended;
Function DT2Sec (dt:TDateTime):extended;
  {    msec  }
procedure Delay (msec:dword);
  {  }
FUNCTION ExStrMSNB (s,d:string):string;
   //  - 1,  - 2 ...  - 7
function RusDayOfWeek (dDate :TDateTime ) : integer;


  //   ParamStr     ParNum
  //     #0
  //    ","  "="
Procedure ExParam     (ParamStr:string; var ParamData:TStringList);
function  ExSinglePar (ParamStr:string; ParNumber:integer):string;
function  ExPar       (ParamStr:string; ParNumber:integer):string;
function  oldExPar    (ParamStr:string; ParNumber:integer):string;

  //  i-    (  -   )
function exWord (s:string; i:integer):string;

  //     ParNumber  str  ParamStr
function SetSinglePar (str:string; ParNumber:integer; ParamStr:string; Sep:Char):string;
function setPar (str:string; ParNumber:integer; ParamStr:string; Sep:Char):string;

  //     ini 
procedure WriteSectionValues (Sender:TObject;Section:string;Ts:TStrings;Name:string);
Procedure DelIdent (VStrings:TStrings);

  //     integer
function HexToInt (hex:string):longInt;
function h2i (hex:string):longInt;
  //    P   I
function IncPtr (p:pointer; i:integer):pointer;
  //  Int64   , len - -  
function Int64ToBin (i:int64; len, fmt:integer):string;
function i2b (i:int64; len, fmt:integer):string;
  //     Int64
function BinToInt64 (b:string):int64;
function b2i (b:string):int64;

function i2s(Value: Integer): string; overload;
function i2s(Value: Int64): string; overload;

function s2i  (const S: string): Integer;
function s2i64(const S: string): Int64;

function f2s (Value: Extended): string;
function s2f (const S: string): Extended;


  {    }
function GetFDateTime (const FileName:string):TDateTime;
function GetFSize     (FileName:string):int64;
   //       .
function GetDirsList (StartDir:string; Attr:string; SortMode:boolean):string;
   //       .
function GetFilesList (StartDir:string; Attr:string; SortMode:boolean):string;
   //      string
function LoadStringFromFile (fn:string):string;
function SaveStringToFile (fn,src:string; clearIfExists:boolean):boolean;
   //    :  #W#X#Y...#Z
function ConvertStringToChars(s:string):string;
function SaveConvStringToFile(fn,src:string; lineLength:integer; LineEndString:string; clearIfExists:boolean):boolean;

  {    }
Procedure Set_Printer_Scale;
Function  PrnX (MM:Real):LongInt;
Function  PrnY (MM:Real):LongInt;
Function  Font_To_MM (NPixels:LongInt):Real;
Function  MM_To_Font (MMSize:Real):LongInt;
Procedure PrnLine (x1,y1,x2,y2:Real);
Procedure PrnTextOut (x1,y1:Real;strText:string);
Procedure PrnRectangle (x1,y1,x2,y2:Real);
Procedure PrnBox (x,y,XLength,YLength:Real);
Procedure PrnFillBox (x,y,XLength,YLength:Real);
Procedure PrnStretchDraw (x1,y1,XLength,YLength:Real; bm:TObject);

  {      }
function GenerateSalt(len:integer):string;
function sXORkey (source,key:string):string;
function CharToHex (source:string):string;
function HexToChar (source:string):string;

function BuffToHex (source:array of char):string;
function HexToBuff (source:string; var dest:Array Of Char):boolean;

  {}
function CheckDoubleStart (name:string):HWND;

  //----------------
  //     COLORS
  //----------------
function Color2RGB (Color:TColor):TRGB;
function RGB2Color (rgb:TRGB):TColor;
function Color2BGR (color:TColor):integer;
function BGR2Color (color:integer):TColor;
                                       //    / (Celeron 300) :
  //  (%). 0 - , 1 - color, > 1 -  
function FadeColor   (color:TColor; mProc:double):TColor;                       // 2.9*10^6
  //      
function GetMidColor (Color1, Color2 : TColor; mProc:double): TColor;           // 2.5*10^6
  //      
function GetColorFromList (const Colors:Array of TColor; mProc:double): TColor; // 1.3*10^6
  //     1:1
function MixColors (color1,color2:TColor):TColor;                               // 8.3*10^6
  //      0(color1)....1(color2)
function MixGlassColors (color1,color2:TColor; proc:double):TColor;             // 2.2*10^6
  //  
function SumColors (color1,color2:TColor):TColor;                               // 8.3*10^6
  // / :  -1(min)...0(color)...1(max)
function BrightColor (color:TColor; mProc:double):TColor;                       // 2.6*10^6
  //   0(/)..1(color)
function SaturateColor (color:TColor; proc:double):TColor;                      // 2.2*10^6
  //       :  -1(min)...0(current)...1(max)
function ShiftColorPalette (color:TColor; RProc,GProc,BProc:double):TColor;     // 1.7*10^6

function qPutPixel    (bm:TBitmap;x,y:integer;BGR:integer):boolean;
function qGetPixel    (bm:TBitmap;x,y:integer):integer;
function qGetPutPixel (bm:TBitmap;x,y:integer;BGR:integer):integer;

procedure bResetImageBitmapLinesRecord (var b:TBitmapLinesRecord; im:TImage);
procedure bResetBitmapLinesRecord      (var b:TBitmapLinesRecord; bm:TBitmap);
function  bPutPixel    (b:PBitmapLinesRecord; x,y:integer; BGR:integer):boolean;
function  bGetPixel    (b:PBitmapLinesRecord; x,y:integer):integer;
function  bGetPutPixel (b:PBitmapLinesRecord; x,y:integer; BGR:integer):integer;

function iLine      (Obj:TPersistent; x1,y1,x2,y2:double; color:TColor):boolean;overload;
function iLine      (Obj:TPersistent; X1,Y1,X2,Y2:double):boolean;overload;

function iRectangle (Obj:TPersistent; x1,y1,x2,y2:double; color:TColor):boolean;overload;
//function iRectangle (Obj:TPersistent; x1,y1,x2,y2:double):boolean;overload;

function iBox       (Obj:TPersistent; x,y,XLength,YLength:double; color:TColor):boolean;overload;
//function iBox       (Obj:TPersistent; x,y,XLength,YLength:double):boolean;overload;

function iFillBox   (Obj:TPersistent; x,y,XLength,YLength:double; color, brushColor:TColor):boolean;overload;
//function iFillBox   (Obj:TPersistent; x,y,XLength,YLength:double):boolean;overload;

implementation


  constructor TNilClass.Create (NewInstanceAddress:pointer);
  begin
    inherited create;
    objInstancePrt  := NewInstanceAddress;
    objInstancePrt^ := self;
  end;


  destructor  TNilClass.destroy;
  begin
    inherited destroy;
    objInstancePrt^ := nil;
  end;


  function PortIn(IOport:word):byte; assembler;
  asm
    mov dx,ax
    in al,dx
  end;

  function PortInW(IOport:word):word; assembler;
  asm
    mov dx,ax
    in ax,dx
  end;

  procedure PortOut(IOport:word; Value:byte); assembler;
  asm
    xchg ax,dx
    out dx,al
  end;

  procedure PortOutW(IOport:word; Value:word); assembler;
  asm
    xchg ax,dx
    out dx,ax
  end;




FUNCTION DelChar (chrWhat:char; strString:string):string;
  {    chrWhat   strString }
var intWhatPosition:integer;  {   chrWhat   }
begin
  Result := strString;
  intWhatPosition := pos (chrWhat,Result);
  while intWhatPosition >0 do
  begin
    delete (Result,intWhatPosition,1);
    intWhatPosition := pos (chrWhat,Result);
  end;
end;


FUNCTION RepChar (chrWhat,chrTo:char; strString:string):string;
var intWhatPosition:integer;  {   chrWhat   }
begin
  Result := strString;
  if chrWhat=chrTo then exit;
  intWhatPosition := pos(chrWhat,Result);
  while intWhatPosition>0 do
  begin
    Result[intWhatPosition] := chrTo;
    intWhatPosition := pos (chrWhat,Result);
  end;
end;



FUNCTION AddLeft (chrWhat:char; NewLength:integer; strString:string):string;
  {  strString   chrWhat  
   byteNewLength }
begin
  Result := strString;
  while length (Result) < NewLength do Result := chrWhat+Result;
end;


FUNCTION AddRight (chrWhat:char; NewLength:integer; strString:string):string;
  {  strString   chrWhat  
   byteNewLength }
begin
  Result := strString;
  while length (Result) < NewLength do Result := Result+chrWhat;
end;


FUNCTION DelNonDigit (strString:string):string;
  {    strString     }
var i:integer;
begin
  Result := '';
  for i:=1 to length(strString) do
    if (strString[i]>='0') and (strString[i]<='9')
    then Result := Result+strString[i];
end;


FUNCTION DelNonHEX (strString:string):string;
  {    strString     }
var i:integer;
begin
  Result := '';
  strString := uppercase(strString);
  for i:=1 to length(strString) do
    if (strString[i] in ['0'..'9','A'..'F']) then Result := Result+strString[i];
end;


FUNCTION DelNonAlphaChar (strString:string):string;
  {    strString     }
var i:integer;
begin
  Result := '';
  for i:=1 to length(strString) do
    if (strString[i] in ['A'..'Z','a'..'z',''..'',''..'']) then Result := Result+strString[i];
end;


function FullTrim (str:string):string;
var i:integer;
begin
  result := trim(str);

  for i:=1 to length(result) do
    if result[i]<#20 then result[i] := ' ';

  i := pos ('  ',result);
  while i>0 do
  begin
    delete (result,i,1);
    i := pos ('  ',result);
  end;
end;


function Translit (str:string):string;
var i,p:integer;
    tr : string;
begin
  result := '';
  for i:=1 to length (str) do
  begin
    p := pos(str[i],translitRus);
    if (p>0) and (str[i]<>' ') then
    begin
      tr := translitLat [p];
      if translitLat [p+1]<>' ' then tr := tr + translitLat [p+1];
      result := result + tr;
    end
    else result := result + str[i];
  end;
end;


FUNCTION ReverseDate (strDate:string):string;
  {     YYMMDD  DDMMYY   }
begin
  Result := strDate;
  if length(Result)<>6 then exit;
  Result := copy(strDate,5,2)+copy(strDate,3,2)+copy(strDate,1,2);
end;


FUNCTION ExDate (strDate:string):string;
  {     DDMMYY  DD.MM.YY }
begin
  Result := strDate;
  if length(Result)<>6 then exit;
  Insert('.',Result,3);
  Insert('.',Result,6);
end;


FUNCTION ExTime (strTime:string):string;
  {     HHMMSS( HHMM)  HH:MM.SS ( HH:MM)}
begin
  Result := strTime;
  if (length(Result)<>6) and (length(Result)<>4) then exit;
  Insert(':',Result,3);
  if (length(Result)=7) then Insert(':',Result,6);
end;


FUNCTION ExTimeShort (strTime:string):string;
  {     HHMMSS  HHMM  HH:MM }
begin
  Result := strTime;
  if (length(Result)<>6) and (length(Result)<>4) then exit;
  Insert(':',Result,3);
  setLength (Result,5);
end;


Function SubTime (Time1,Time2:TDateTime):double;
  {      Time1-Time2}
Const   SecondsPerDay = 24*60*60;           {    }
Begin
   result := (frac(Time1)-frac(Time2))*SecondsPerDay;
End;


Function DateTimeToSec (dt:TDateTime):extended;
Const   SecondsPerDay = 24*60*60;           {    }
Begin
   result := dt*SecondsPerDay;
End;


Function DT2Sec (dt:TDateTime):extended;
begin
  result := DateTimeToSec (dt);
end;


Procedure Delay (msec:dword);
var d:dword;
begin
  d := getTickCount;
  while (getTickCount-d)< msec do Application.ProcessMessages;
end;


function SubTick (oldTick:DWord):DWord;
var count:DWord;
begin
  count  := GetTickCount;
  if count<oldTick then oldTick := high(DWord)-oldTick;
  result := count - oldTick;
end;



Function HexToInt (hex:string):longInt;
var i     : Byte;
    erhex : string;
begin
  hex   := trim(UpperCase(Hex));
  erHex := hex;
  if hex='' then StrToInt (erHex); //   
  while length(hex)>8 do delete(hex,1,1);
  while length(hex)<8 do insert('0',hex,1);
  for i:=1 to 8 do
  begin
    if hex[i] in ['0'..'9'] then hex[i]:=chr(ord(hex[i])-48)
    else
    if hex[i] in ['A'..'F'] then hex[i]:=chr(ord(hex[i])-55)
    else StrToInt (erHex);         //   
  end;
  result := ord(hex[8])+
            ord(hex[7])*16+
            ord(hex[6])*256+
            ord(hex[5])*4096+
            ord(hex[4])*65536+
            ord(hex[3])*1048576+
            ord(hex[2])*16777216+
            ord(hex[1])*268435456;
end;


Function h2i (hex:string):longInt;
begin
  result := HexToInt (hex);
end;


function Int64ToBin (i:int64; len, fmt:integer):string;
var bt   : int64;
    fmtc : integer;
begin
  result := '';
  if len<=0 then len := 1  else if len>64  then len := 64;
  if fmt<=0 then fmt := -1 else if fmt>len then fmt := -1;
  bt   := 1;

  while (bt<>0) and (i<>0) do
  begin
    if (i and bt)=0 then result := '0' + result else result := '1' + result;
    i  := i and (bt xor -1);
    bt := bt shl 1;
  end;

  result := AddLeft ('0',len,result);

  fmtc := fmt;
  while (fmtc>0) and (fmtc<length(result)) do
  begin
    insert (' ',result,length(result) - fmtc + 1);
    fmtc := fmtc + fmt + 1;
  end;

  result := trim (result);
end;


function i2b (i:int64; len, fmt:integer):string;
begin
  result := Int64ToBin (i,len,fmt);
end;


function BinToInt64 (b:string):int64;
var bt:int64;
    n : integer;
begin
  result := 0;
  b  := delNonDigit (b);
  bt := 1;

  for n:=length (b) downto 1 do
  begin
    if b[n]='1' then result := result or bt;
    bt := bt shl 1;
  end;
end;


function b2i (b:string):int64;
begin
  result := BinToInt64(b);
end;


function f2s(Value: Extended): string;
begin
  result := FloatToStr(Value);
end;


function s2f  (const S: string): Extended;
begin
  result := StrToFloat (s);
end;


function i2s(Value: Integer): string;
begin
  result := inttostr(value);
end;


function i2s(Value: Int64): string;
begin
  result := inttostr(value);
end;


function s2i  (const S: string): Integer;
begin
  result := strtoint (s);
end;


function s2i64(const S: string): Int64;
begin
  result := strtoint (s);
end;




FUNCTION ExStrMSNB (s,d:string):string;
begin
  result := d;
  if length (s)>length (result) then
    result := copy (s,1,length(s)-length(result))+result;
end;




{***************************************************************************}



Procedure DelIdent (VStrings:TStrings);
  { .INI  :       ='}
  {   TIniFile.ReadSectionValues}
var i    :word;
    equal:byte;
    s    :string;
Begin
if VStrings.Count>0 then
  for i:=0 to VStrings.Count-1 do
    begin
      equal:=pos('=',VStrings.strings[i]);
      if equal<>0 then
        begin
          s:=VStrings.strings[i];
          delete(s,1,equal);
          VStrings.strings[i]:=s;
        end;
    end;
End;


procedure WriteSectionValues (Sender:TObject; Section:string; Ts:TStrings; Name:string);
var i:integer;
begin
  if Ts.count>0 then
    for i:=0 to Ts.count-1 do
      (Sender as TIniFile).WriteString (Section,Name+Format('%.3d',[i]),Ts[i]);
end;


Procedure ExParam (ParamStr:string; var ParamData:TStringList);
  {    (  ','  '='}
var Comma : word;
    Equal : word;
    p     : word;
Begin
  Comma:=pos(',',ParamSTR);
  Equal:=pos('=',ParamSTR);
  if ((comma>0) and (comma<equal)) or (equal=0) then p:=comma else p:=equal;
  ParamData.Clear;
  while p<>0 do
  begin
    ParamData.Add (trim(copy(ParamSTR,1,p-1)));
    delete (ParamSTR,1,p);
    Comma:=pos(',',ParamSTR);
    Equal:=pos('=',ParamSTR);
    if ((comma>0) and (comma<equal)) or (equal=0) then p:=comma else p:=equal;
  end;
  ParamData.Add (trim(ParamSTR));  { }
End;


function ExSinglePar (ParamStr:string; ParNumber:integer):string;
var st : TStringList;
begin
  result := #0;
  st     := TStringList.create;
  ExParam (ParamStr, st);
  if (ParNumber>=0)and(ParNumber<st.count) then result := st.strings[ParNumber];
  st.free;
end;


function oldExPar (ParamStr:string; ParNumber:integer):string;
begin
  result := ExSinglePar (ParamStr,ParNumber);
end;


function ExPar (ParamStr:string; ParNumber:integer):string;
var pr,pi,pn : integer;
begin
  result := #0;
  if ParNumber<0 then exit;
  pn := pos('=',ParamStr);
  while pn>0 do
  begin
    ParamStr[pn] := ',';
    pn := pos('=',ParamStr);
  end;
  pi := 0;
  pr := 0;
  pn := pos(',',ParamStr);
  if (pn=0) and (pi=parnumber) then result := trim (ParamStr)
  else
    while (pn>0) and (pr<>pn) and (pi<=ParNumber) do
    begin
      if pi=parnumber then result := trim(copy(ParamStr,pr+1,pn-pr-1))
      else ParamStr[pn] := '~';
      pr := pn;
      pn := pos(',',ParamStr);
      if pn=0 then pn:=length(ParamStr)+1;
      inc(pi);
    end;
end;


  //  i-    (  -   )
function exWord(s:string; i:integer):string;
var st:TStringList;
begin
  result := #0;
  st     := TStringList.Create;
  st.CommaText := s;
  if i<st.Count then result := st[i];
  st.free;
end;



function setPar (str:string; ParNumber:integer; ParamStr:string; Sep:Char):string;
begin
  result := SetSinglePar (str,ParNumber,ParamStr,Sep);
end;


function SetSinglePar (str:string; ParNumber:integer; ParamStr:string; Sep:Char):string;
var st : TStringList;
    i  : integer;
begin
  result := ParamStr;
  st     := TStringList.create;
  ExParam (ParamStr, st);
  if (ParNumber>=0)and(ParNumber<st.count) then
  begin
    st.strings[ParNumber] := str;
    i        := 0;
    ParamStr := '';
    while i<st.count do
    begin
      if i<>parNumber then ParamStr := ParamStr + st.strings[i]+','
      else ParamStr := ParamStr + st.strings[i] + sep;
      inc(i);
    end;
    ParamStr:=copy (ParamStr,1,Length(ParamStr)-1); //   ','
    result := ParamStr;
  end;
  st.free;
end;

{***************************************************************************}


Procedure Set_Printer_Scale;
  {    }
Begin
  PrinterResX := GetDeviceCaps (Printer.Handle, LOGPIXELSX);
  PrinterResY := GetDeviceCaps (Printer.Handle, LOGPIXELSY);
  PrinterAspectRatio := PrinterResX/PrinterResY;
  PrinterPageHeight := Printer.PageHeight/PrinterResY*25.4;
  PrinterPageWidth  := Printer.PageWidth/PrinterResX*25.4;
End;


Function PrnX (MM:Real):LongInt;
  {   X      }
begin
  Result := Round(MM*PrinterResX/25.4);
end;


Function PrnY (MM:Real):LongInt;
  {   Y      }
Begin
  Result := Round(MM*PrinterResY/25.4);
End;


Function Font_To_MM (NPixels:LongInt):Real;
  {         mm }
Begin
  Result := Round(NPixels*25.4/72);
End;


Function MM_To_Font (MMSize:Real):LongInt;
  {     mm     }
Begin
  Result := Round(MMSize*72/25.4);
End;


Procedure PrnLine (x1,y1,x2,y2:Real);
  {   (   ) }
Begin
  Printer.Canvas.MoveTo(PrnX(x1),PrnY(y1));
  Printer.Canvas.LineTo(PrnX(x2),PrnY(y2));
End;


Procedure PrnRectangle (x1,y1,x2,y2:Real);
  {   (   ) }
Begin
  PrnLine (x1,y1,x2,y1);
  PrnLine (x2,y1,x2,y2);
  PrnLine (x2,y2,x1,y2);
  PrnLine (x1,y2,x1,y1);
End;


Procedure PrnBox (x,y,XLength,YLength:Real);
  {   (   ) }
Begin
  PrnLine (x,         y,         x+XLength, y);
  PrnLine (x+XLength, y,         x+XLength, y+YLength);
  PrnLine (x+XLength, y+YLength, x,         y+YLength);
  PrnLine (x,         y+YLength, x,         y);
End;


Procedure PrnFillBox (x,y,XLength,YLength:Real);
  {  }
Var R:TRect;
Begin
  R.left   := PrnX(x);
  R.top    := PrnY(y);
  R.right  := PrnY(x+xLength);
  R.bottom := PrnY(y+yLength);
  Printer.Canvas.FillRect (R);
End;


Procedure PrnTextOut (x1,y1:Real;strText:string);
  {     x1,y1 ( ) }
Begin
  Printer.Canvas.TextOut (PrnX(x1),PrnY(y1),strText);
End;


Procedure PrnStretchDraw (x1,y1,XLength,YLength:Real; bm:TObject);
  {     x1,y1, XLength   YLength ( ) }
Var R:TRect;
Begin
  R.Left   := PrnX(x1);
  R.Right  := PrnY(x1+XLength);
  R.Top    := PrnY(y1);
  R.Bottom := PrnY(y1+YLength);
  Printer.Canvas.StretchDraw(r ,(bm as TGraphic));
End;


{***************************************************************************}
{                         
{***************************************************************************}

function GetFDateTime (const FileName:string):TDateTime;
begin
  result := -1;
  try
    if not fileexists (FileName) then exit;
    result := FileDateToDateTime (FileAge(FileName));
  except result := -1 end;
end;


function GetFSize (FileName:string):int64;
var HFile : THandle;
    Size  : dWord;
begin
  try
    result   := -1;
    FileName := FileName + #0;
    HFile := _lopen (@FileName[1],OF_READ);
    if HFile=HFILE_ERROR then exit;
    Size := GetFileSize (HFile,@Size);
    _lClose(HFile);
    if Size<>$FFFFFFFF then result := Size;
  except result := -1 end;
end;


(*          .  *)

function GetDirsList (StartDir:string; Attr:string; SortMode:boolean):string;
var SearchRec : TSearchRec;
    i, count  : integer;
    Dirs : TStringList;
begin
  result := '';
  try
    count := 0;
    i := FindFirst(StartDir+'\'+Attr, faDirectory, SearchRec);
    while i=0 do
    begin
      if (SearchRec.Attr and faDirectory)>0 then
      begin
        inc(count);    //    '.'  '..'
        if count>2 then result := result + LowerCase(SearchRec.name) + ',';
      end;
      i := FindNext(SearchRec);
    end;
    FindClose (SearchRec);
    if result<>'' then delete(result,length(result),1);
    Dirs := TStringList.create;
    Dirs.CommaText := result;
    case SortMode of
      constNoSort : ;
      constSort   : Dirs.sort;
    end;
    result := Dirs.CommaText;
    Dirs.free;
  except
    result := '';
  end;
end;

(*           .  *)

function GetFilesList (StartDir:string; Attr:string; SortMode:boolean):string;
var SearchRec : TSearchRec;
    i :integer;
    Files : TStringList;
begin
  result := '';
  try
    if StartDir[length(StartDir)]<>'\' then StartDir:=StartDir+'\';
    i := FindFirst(StartDir + Attr, faAnyFile, SearchRec);
    while i=0 do
    begin
      if (SearchRec.Attr and faDirectory)=0 then
        result := result + LowerCase(SearchRec.name) + ',';
      i := FindNext(SearchRec);
    end;
    FindClose (SearchRec);
    if result<>'' then delete(result,length(result),1);
    Files := TStringList.create;
    Files.CommaText := result;
    case SortMode of
      constNoSort : ;
      constSort   : Files.sort;
    end;
    result := Files.CommaText;
    Files.free;
  except
    result := '';
  end;
end;


function LoadStringFromFile(fn:string):string;
var F   : file of char;
    Buf : array[1..2048] of Char;
    NumRead : integer;
begin
  result := '';
  assignFile (f,fn);
  reset      (f);
  repeat
    BlockRead (F, Buf, SizeOf(Buf), NumRead);
    result := result + copy (Buf,1,NumRead);
  until NumRead=0;
  closeFile (f);
end;


function SaveStringToFile(fn,src:string; clearIfExists:boolean):boolean;
var F : Text;
begin
  result := true;
  try
    assignFile (f,fn);
    case fileexists(fn) of
      true  : if clearIfExists then rewrite (f) else append (f);
      false : rewrite (f);
    end;
    write (F, src);
    closeFile (f);
  except
    result := false;
  end;
end;



function ConvertStringToChars(s:string):string;
var i:integer;
begin
  result := '';
  for i:=1 to length(s) do
    result := result + '#' + i2s(ord(s[i]));
end;


function SaveConvStringToFile(fn,src:string; lineLength:integer; LineEndString:string; clearIfExists:boolean):boolean;
var F : Text;
    l : integer;
    s:string;
begin
  result := true;
  try
    assignFile (f,fn);
    case fileexists(fn) of
      true  : if clearIfExists then rewrite (f) else append (f);
      false : rewrite (f);
    end;

    while length(src)>0 do
    begin
      s := copy(src,1,lineLength);
      delete (src,1,lineLength);
      l :=pos('#',src);
      if l>1 then
      begin
        s := s + copy (src,1,l-1);
        delete (src,1,l-1);
      end;
      s := s + LineEndString;
      writeln (f,s);
    end;
    closeFile (f);
  except
    result := false;
  end;
end;


function CheckDoubleStart (name:string):HWND;
begin
  result :=  FindWindow(nil,pChar(name));
end;



function IncPtr (p:pointer; i:integer):pointer;
asm
  push ebx
  mov  ebx, eax
  add  ebx, edx
  mov  eax, ebx
  pop  ebx
end;


//-----------------------------------------------------------------------
//---              
//---
//-----------------------------------------------------------------------


  //      LEN

  function GenerateSalt(len:integer):string;
  begin
    result := '';
    randomize;
    while length(result)<len do
      result := result + char(random(255));
  end;


  //  key  source  xor

  function sXORkey (source,key:string):string;
  var i:integer;
  begin
    result := '';
    try
      i    := 1;
      if (key='') then exit;
      while length(result)<length(source) do
      begin
        result := result + char(ord(source[length(result)+1]) xor ord(key[i]));
        inc (i);
        if i>length(key) then i:=1;
      end;
    except
      result := '';
    end;
  end;

      //       (HEX ANSI)
  function CharToHex (source:string):string;
  var i:integer;
  begin
    result := '';
    for i:=1 to Length (source) do result := result + IntToHex(ord(source[i]),2);
  end;


    //   HEX ANSI   CHAR
  function HexToChar (source:string):string;
  var i:integer;
  begin
    result := '';
    try
      for i:=1 to trunc(length(source)/2) do
        result := result + chr(HexToInt(copy(source,i*2-1,2)));
    except
      result := '';
    end;
  end;

      //       (HEX ANSI)
  function BuffToHex (source:array of char):string;
  var i:integer;
  begin
    result := '';
    for i:=Low(source) to High(source) do result := result + IntToHex(ord(source[i]),2);
  end;


  function HexToBuff (source:string; var dest:Array Of Char):boolean;
  var i:integer;
  begin
    result := true;
    if sizeof (dest)=0 then exit;
    try
      for i:=0 to round(length(source)/2)-1 do
        dest[low(dest)+i] := chr(HexToInt(copy(source,i*2+1,2)));
    except
      result := false;
    end;
  end;



   //  - 1,  - 2 ...  - 7
  function RusDayOfWeek (dDate :TDateTime ) : integer;
  begin
    result := DayOfWeek (dDate);
    dec (result);
    if result = 0 then result := 7;
  end;

//------------------------------------------------------------------------
//                               COLORs
//------------------------------------------------------------------------

  function BGR2Color (color:integer):TColor;
  var rgb : TRGB;
      tmpBlue : byte;
  begin
    rgb.color := color;
    tmpBlue   := rgb.red;
    rgb.red   := rgb.blue;
    rgb.blue  := tmpBlue;
    result    := rgb.color;
  end;

  function Color2BGR (color:TColor):integer;
  begin
    result := BGR2Color(color);
  end;

  function Color2RGB (Color:TColor):TRGB;
  begin
    result.color := color;
  end;


  function RGB2Color (rgb:TRGB):TColor;
  begin
    rgb.nu := 0;
    result := rgb.color;
  end;




  function MixColors (color1,color2:TColor):TColor;
  var rgb1,rgb2,rgb : TRGB;
  begin
    rgb1.color := color1;
    rgb2.color := color2;
    rgb.red   := (rgb1.red   + rgb2.red)   div 2;
    rgb.blue  := (rgb1.blue  + rgb2.blue)  div 2;
    rgb.green := (rgb1.green + rgb2.green) div 2;
    rgb.nu    := 0;
    result    := rgb.color;
  end;


  function MixGlassColors (color1,color2:TColor; proc:double):TColor;
  var rgb1,rgb2,rgb : TRGB;
  begin
    rgb1.color := color1;
    rgb2.color := color2;
    if abs(proc)>1 then proc := frac(proc);
    if proc<0 then proc := abs(proc);
    rgb.red   := round((rgb1.red*(1-proc)   + rgb2.red*proc));
    rgb.blue  := round((rgb1.blue*(1-proc)  + rgb2.blue*proc));
    rgb.green := round((rgb1.green*(1-proc) + rgb2.green*proc));
    rgb.nu    := 0;
    result    := rgb.color;
  end;


  function SumColors (color1,color2:TColor):TColor;
  var rgb1,rgb2,rgb : TRGB;
      irgb : TiRGB;
  begin
    rgb1.color := color1;
    rgb2.color := color2;
    with irgb do begin
      ired   := rgb1.red   + rgb2.red;    if ired>255   then ired   := 255;
      igreen := rgb1.green + rgb2.green;  if igreen>255 then igreen := 255;
      iblue  := rgb1.blue  + rgb2.blue;   if iblue>255  then iblue  := 255;
      rgb.red := ired; rgb.green := igreen; rgb.blue := iblue; rgb.nu := 0;
    end;
    result := rgb.color;
  end;


  function FadeColor (color:TColor; mProc:double):TColor;
  var rgb  : TRGB;
      iRgb : TiRGB;
  begin
    rgb.color := color;
    if mProc<0 then mProc := abs(mProc);
    with iRGB do
      with rgb do begin
        ired   := round (red*mProc);   if ired>255   then ired   := 255;
        igreen := round (green*mProc); if igreen>255 then igreen := 255;
        iblue  := round (blue*mProc);  if iblue>255  then iblue  := 255;
        red := ired; green := igreen; blue := iblue; nu := 0;
      end;
    result := rgb.color;
  end;


  function BrightColor (color:TColor; mProc:double):TColor;                       //
  var rgb      : TRGB;
      relColor : TRGB;
  begin
    rgb.color := color;
    if abs(mProc)>1 then mProc := frac(mProc);
    with rgb do begin
      if mProc>0 then relColor.color := $00FFFFFF - rgb.color
      else            relColor.color := rgb.color;
      red   := red   + round (relColor.red*mProc);
      green := green + round (relColor.green*mProc);
      blue  := blue  + round (relColor.blue*mProc);
      nu    := 0;
    end;
    result := rgb.color;
  end;


  function SaturateColor (color:TColor; proc:double):TColor;
  var rgb : TRGB;
      midValue : integer;
  begin
    rgb.color := color;
    midValue  := round((rgb.red+rgb.green+rgb.blue)*0.33);
    rgb.red   := round(midValue + (rgb.red-midValue)*proc);
    rgb.green := round(midValue + (rgb.green-midValue)*proc);
    rgb.blue  := round(midValue + (rgb.blue-midValue)*proc);
    result    := rgb.color;
  end;


  function GetMidColor (Color1, Color2 : TColor; mProc:double): TColor;
  var fromRGB, toRGB, rgb : TRGB;
  begin
    fromRGB.color := Color1;
    toRGB.color   := Color2;
    if mProc>1 then mProc := frac (mProc)
    else if mProc<0 then mProc := abs(mProc);
    rgb.red   := round(fromRGB.Red   + (toRGB.Red - fromRGB.Red)*mProc);
    rgb.green := round(fromRGB.Green + (toRGB.Green - fromRGB.Green)*mProc);
    rgb.blue  := round(fromRGB.blue  + (toRGB.blue - fromRGB.blue)*mProc);
    rgb.nu    := 0;
    result    := rgb.color;
  end;


  function GetColorFromList (const Colors:Array of TColor; mProc:double): TColor;
  var i1, i2, hc : integer;
  begin
    hc := high(Colors);
    if (hc<0) or (mProc<0) then result := clBlack
    else begin
      if mProc>1 then mProc := 1;
      i1 := round (hc*mProc-0.5);
      i2 := i1 + 1; if i2>hc then i2 := i1;
      result := GetMidColor (Colors[i1], Colors[i2], hc*mProc-i1);
    end;
  end;


  function ShiftColorPalette (color:TColor; RProc,GProc,BProc:double):TColor;
  var rgb      : TRGB;
      relColor : TRGB;
  begin
    rgb.color := color;
    if abs(RProc)>1 then RProc := frac(RProc);   //    
    if abs(GProc)>1 then GProc := frac(GProc);   //  -- // -- // -- // -- //
    if abs(BProc)>1 then BProc := frac(BProc);   //  -- // -- // -- // -- //
    with rgb do begin
      if RProc>0 then relColor.red   := $FF - red   else relColor.red   := red;
      if GProc>0 then relColor.green := $FF - green else relColor.green := green;
      if BProc>0 then relColor.blue  := $FF - blue  else relColor.blue  := blue;
      red   := red   + round (relColor.red*RProc);
      green := green + round (relColor.green*GProc);
      blue  := blue  + round (relColor.blue*BProc);
      nu    := 0;
    end;
    result := rgb.color;
  end;

//------------------------------------------------------------------------

  function qPutPixel (bm:TBitmap;x,y:integer;BGR:integer):boolean;
  var il : PIntArray;
  begin
    if (x>=0) and (x<bm.width) and (y>=0) and (y<bm.height) then
    begin
      il := bm.scanline[y];
      il[x]  := BGR;
      result := true;
    end
    else result := false;
  end;


  function qGetPixel (bm:TBitmap;x,y:integer):integer;
  var il : PIntArray;
  begin
    if (x>=0) and (x<bm.width) and (y>=0) and (y<bm.height) then
    begin
      il := bm.scanline[y];
      result := il[x];
    end
    else result := -1;
  end;


  function qGetPutPixel (bm:TBitmap;x,y:integer;BGR:integer):integer;
  var il : PIntArray;
  begin
    if (x>=0) and (x<bm.width) and (y>=0) and (y<bm.height) then
    begin
      il := bm.scanline[y];
      result := il[x];
      il[x]  := BGR;
    end
    else result := -1;
  end;



//---------------------------------------------------------------------------------
  procedure bResetImageBitmapLinesRecord (var b:TBitmapLinesRecord; im:TImage);
  begin
    im.Picture.Bitmap.Width       := im.Width;
    im.Picture.Bitmap.Height      := im.height;
//    im.picture.bitmap.pixelformat := pf32bit;
    bResetBitmapLinesRecord (b,im.Picture.Bitmap);
  end;

  procedure bResetBitmapLinesRecord (var b:TBitmapLinesRecord; bm:TBitmap);
  var i:integer;
  begin
    bm.pixelformat := pf32bit;
    setlength (b.lines,bm.Height);
    b.height := bm.Height;
    b.width  := bm.Width;
    for i:=0 to bm.Height-1 do b.lines[i] := bm.scanline[i];
  end;


  function bPutPixel (b:PBitmapLinesRecord; x,y:integer; BGR:integer):boolean;
  begin
    if (x>=0) and (x<=b.width) and (y>=0) and (y<=high(b.lines)) then
    begin
      b.lines[y]^[x] := BGR;
      result := true;
    end
    else result := false;
  end;


  function bGetPixel (b:PBitmapLinesRecord; x,y:integer):integer;
  begin
    if (x>=0) and (x<=b.width) and (y>=0) and (y<=high(b.lines)) then
      result := b.lines[y]^[x]
    else result := -1;
  end;


  function bGetPutPixel (b:PBitmapLinesRecord; x,y:integer; BGR:integer):integer;
  begin
    if (x>=0) and (x<=b.width) and (y>=0) and (y<=high(b.lines)) then
    begin
      result := b.lines[y]^[x];
      b.lines[y]^[x] := BGR;
    end
    else result := -1;
  end;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------

  function iGetObjectCanvas (obj:TPersistent):TCanvas;
  begin
    result := nil;
    if Obj is TImage  then result := (Obj as TImage).Canvas  else
    if Obj is TBitmap then result := (Obj as TBitmap).Canvas else
    if Obj is TCanvas then result := (Obj as TCanvas);
  end;


  function  iLine (Obj:TPersistent; X1,Y1,X2,Y2:double):boolean;
  var Canvas   : TCanvas;
  begin
    result := false;
    Canvas := iGetObjectCanvas (obj);
    if not assigned(Canvas) then exit;
    Canvas.MoveTo (round(x1),round(y1));
    Canvas.LineTo (round(x2),round(y2));
    result := true;
  end;


  function  iLine (Obj:TPersistent; X1,Y1,X2,Y2:double; color:TColor):boolean;
  var Canvas   : TCanvas;
  begin
    result := false;
    Canvas := iGetObjectCanvas (obj);
    if not assigned(Canvas) then exit;
    Canvas.Pen.Color := Color;
    Canvas.MoveTo (round(x1),round(y1));
    Canvas.LineTo (round(x2),round(y2));
    result := true;
  end;


  function iRectangle (Obj:TPersistent; x1,y1,x2,y2:double; color:TColor):boolean;
  begin
    result := true;
    try
      iLine (Obj,x1,y1,x2,y1,color);
      iLine (Obj,x2,y1,x2,y2,color);
      iLine (Obj,x2,y2,x1,y2,color);
      iLine (Obj,x1,y2,x1,y1,color);
    except result := false end;
  end;



  function iBox (Obj:TPersistent; x,y,XLength,YLength:double; color:TColor):boolean;
  begin
    result := true;
    try
      iLine (Obj,x,         y,         x+XLength, y        ,color);
      iLine (Obj,x+XLength, y,         x+XLength, y+YLength,color);
      iLine (Obj,x+XLength, y+YLength, x,         y+YLength,color);
      iLine (Obj,x,         y+YLength, x,         y        ,color);
    except result := false end;
  end;


  function iFillBox (Obj:TPersistent; x,y,XLength,YLength:double; color, brushColor:TColor):boolean;
  var Canvas : TCanvas;
  begin
    result := false;
    Canvas := iGetObjectCanvas (obj);
    if not assigned(Canvas) then exit;
    Canvas.Pen.Color   := color;
    Canvas.Brush.Color := brushColor;
    Canvas.Rectangle (round(x), round(y), round(x+xLength), round(y+YLength));
  end;


end.
