//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_Exporter                                                   *//
//* Author:  Dark Magus                                                     *//
//* Date:    05.01.02                                                       *//
//*                                                                         *//
//*  ,        -  *//
//*       Dream Journal "Wizardry" (v. 2.0).         *//
//*                                                                         *//
//***************************************************************************//
unit drj_Exporter;

//-[ INTERFACE ]---------------------------------------------------------------
interface

uses
  xml_Node;

type TExporter = class (TObject)
  protected
    END_LINE  : String;
    SEPARATOR : String;
    SPACE     : String;

    flagNames : array[1..4] of String;

    function GetBody (iNode : TXMLNode) : String; virtual;
    function GetHeader (iNode : TXMLNode) : String; virtual;
    function GetFooter (iNode : TXMLNode) : String; virtual;
    function GetNSpaces (N : Integer) : String;

  public
    constructor Create;
    destructor Destroy; override;

    procedure ExportNode (iNode : TXMLNode; var iFile : TextFile);

  published
    property Flag_1 : String read flagNames[1] write flagNames[1];
    property Flag_2 : String read flagNames[2] write flagNames[2];
    property Flag_3 : String read flagNames[3] write flagNames[3];
    property Flag_4 : String read flagNames[4] write flagNames[4];

end;

resourcestring
  DREAM_JOURNAL_STRING         = ' ';
  DREAM_LIBRARY_STRING         = ' ';
  DAY_COMMENT_STRING           = ' : ';
  EXPERIENCE_COMMENT_STRING    = ' : ';
  ENERGY_LEVEL_STRING          = ' : ';
  IMAGE_STRING                 = ': ';
  PROPERTIES_STRING            = ':';
  ADDITIONAL_PROPERTIES_STRING = ' : ';
  YES_STRING                   = '';
  NO_STRING                    = '';
  NO_PROPERTIES_STRING         = ' ';
  USER_STRING                  = ':';
  NAME_STRING                  = ': ';
  NICK_STRING                  = ': ';
  EMAIL_STRING                 = ' : ';
  AGE_STRING                   = ': ';
  SEX_STRING                   = ': ';
  MASCULINUM_STRING            = '';
  FEMININUM_STRING             = '';
  SMILE_STRING                 = ':)';
  ADDITIONAL_STRING            = ' : ';
  FILELIST_STRING              = '   : ';
  USER_PROPERTIES_STRING       = ' ';
  TABLE_STRING                 = '';
  LIBRARY_STRUCTURE_STRING     = '  ';
  ADDITIONAL_FILES_STRING      = '  ';
  DICTIONARY_STRING            = '';
  VOCABULARY_STRING            = '';
  PROPERTY_STRING              = '';
  VALUE_STRING                 = '';

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

constructor TExporter.Create;
begin
  inherited Create;
  END_LINE := #13#10;
  SEPARATOR := '';
  SPACE := '';
end;

destructor TExporter.Destroy;
begin
  inherited Destroy;
end;

function TExporter.GetNSpaces (N : Integer) : String;
var
  i : Integer;
begin
  Result := '';
  if (N > 0) then
  begin
    for i := 1 to N do
    begin
      Result := Result + SPACE;
    end;
  end;
end;

procedure TExporter.ExportNode (iNode : TXMLNode; var iFile : TextFile);
begin
  WriteLn (iFile, GetHeader (iNode));
  WriteLn (iFile, GetBody (iNode));
  WriteLn (iFile, GetFooter (iNode));
end;

function TExporter.GetBody (iNode : TXMLNode) : String;
begin
  Result := '';
end;

function TExporter.GetHeader (iNode : TXMLNode) : String;
begin
  Result := '';
end;

function TExporter.GetFooter (iNode : TXMLNode) : String;
begin
  Result := '';
end;

//-[ END ]---------------------------------------------------------------------
end.
