//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_Resources                                                  *//
//* Author:  Dark Magus                                                     *//
//* Date:    17.08.01                                                       *//
//*                                                                         *//
//*            *//
//*   Dream Journal (v. 2.0).                                       *//
//*                                                                         *//
//***************************************************************************//
unit drj_JournalHash;

//-[ INTERFACE ]---------------------------------------------------------------
interface

uses
  classes,
  
  drj_Types,

  xml_mainUnit;

type TJournalHash = class (TObject)
  private
    FXMLHash      : TList;

  public
    property XMLHash      : TList read FXMLHash;

    constructor Create;
    destructor Destroy; override;

    procedure SaveAll;
    procedure AddXMLParser (xmlParser : TXMLParser);

    function GetXMLParser (const fileName : String) : TXMLParser;

end;

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

constructor TJournalHash.Create;
begin
  inherited Create;
  FXMLHash := TList.Create;
end;

destructor TJournalHash.Destroy;
var
  i         : Integer;
  xmlParser : TXMLParser;
begin
  for i := 0 to FXMLHash.Count - 1 do
  begin
    xmlParser := FXMLHash.Items[i];
    xmlParser.SaveFile (xmlParser.FileName);
    xmlParser.Free;
  end;
  FXMLHash.Clear;
  FXMLHash.Free;
  inherited Destroy;
end;

function TJournalHash.GetXMLParser (const fileName : String) : TXMLParser;
var
  i           : Integer;
  xmlParser   : TXMLParser;
begin
  for i := 0 to FXMLHash.Count - 1 do
  begin
    xmlParser := FXMLHash.Items[i];
    if (xmlParser.FileName = fileName) then
    begin
      Result := xmlParser;
      Exit;
    end;
  end;
  { DONE 5 -cMethod -oDark Magus :       . }
  xmlParser := TXMLParser.Create;
  xmlParser.FileName := fileName;
  FXMLHash.Add (xmlParser);
  Result := xmlParser;
end;

procedure TJournalHash.SaveAll;
var
  i         : Integer;
  xmlParser : TXMLParser;
begin
  for i := 0 to FXMLHash.Count - 1 do
  begin
    xmlParser := FXMLHash.Items[i];
    xmlParser.SaveFile (xmlParser.FileName);
  end;
end;

procedure TJournalHash.AddXMLParser (xmlParser : TXMLParser);
begin
  FXMLHash.Add (xmlParser);
end;

//-[ END ]---------------------------------------------------------------------
end.
