//***************************************************************************//
//*                                                                         *//
//* Unit:    drj_Resources                                                  *//
//* Author:  Dark Magus                                                     *//
//* Date:    14.08.01                                                       *//
//*                                                                         *//
//*     ,    .   Dream    *//
//* Journal (v. 2.0).                                                       *//
//*                                                                         *//
//***************************************************************************//
unit drj_Resources;

//-[ INTERFACE ]---------------------------------------------------------------
interface

const
  INI_FILE_NAME              : String = 'dreams.ini';
  UNDEFINED_VALUE            : String = 'undefined';
  TRUE_VALUE                 : String = 'true';
  FALSE_VALUE                : String = 'false';
  NAME_DELIMITER             : String = '. ';
  EMPTY_GRAPHIC_FILE         : String = 'empty.bmp';
  STR_OPENED_NODE            : String = 'Opened Node';
  STR_DREAM_LIBRARY          : String = 'Dream Library';
  STR_DREAM_DIRECTORY        : String = 'Dream Directory';
  STR_DREAM_FILE             : String = 'Dream File';
  STR_ONE_NIGHT              : String = 'One Night';
  STR_ONE_DREAM              : String = 'One Dream';
  STR_YES                    : String = 'yes';
  STR_NO                     : String = 'no';
  DREAM_JOURNAL_STYLESHEET   : String = '<?xml-stylesheet href="../journal.xsl" type="text/xsl"?>';
  DREAM_JOURNAL_DOCTYPE      : String = '<!DOCTYPE dreamjournal SYSTEM "../dream_journal.dtd">';
  DREAM_LIBRARY_STYLESHEET   : String = '<?xml-stylesheet href="library.xsl" type="text/xsl"?>';
  DREAM_LIBRARY_DOCTYPE      : String = '<!DOCTYPE dreamlibrary SYSTEM "dream_library.dtd">';
  HTML_VALUE                 : String = 'html';
  PLAINTEXT_VALUE            : String = 'plaintext';
  STR_MASCULINUM             : String = 'masculinum';
  STR_FEMININUM              : String = 'femininum';
  STR_SMILE                  : String = ':)';

const
  TAG_DREAMLIBRARY           : String = 'dreamlibrary';
  TAG_DREAMJOURNAL           : String = 'dreamjournal';
  TAG_ICON                   : String = 'icon';
  TAG_DIRECTORY              : String = 'directory';
  TAG_FILE                   : String = 'file';
  TAG_DAY                    : String = 'day';
  TAG_EXPERIENCE             : String = 'experience';
  TAG_DESCRIPTION            : String = 'description';
  TAG_COMMENT                : String = 'comment';
  TAG_IMAGE                  : String = 'image';
  TAG_PROPERTIES             : String = 'properties';
  TAG_LABEL                  : String = 'label';
  TAG_ENERGY                 : String = 'energy';
  TAG_FORM                   : String = 'form';
  TAG_OPTIONS                : String = 'options';
  TAG_STATISTIC              : String = 'statistic';
  TAG_GRAPH                  : String = 'graph';
  TAG_POINT                  : String = 'point';
  TAG_LIBRARY                : String = 'library';
  TAG_USER                   : String = 'user';
  TAG_ADDITIONAL             : String = 'additional';
  TAG_DREAM_FORM             : String = 'dream-form';
  TAG_PARAMETER              : String = 'parameter';

const
  ATTRIBUTE_PATH             : String = 'path';
  ATTRIBUTE_NAME             : String = 'name';
  ATTRIBUTE_TITLE            : String = 'title';
  ATTRIBUTE_NUMBER           : String = 'number';
  ATTRIBUTE_LUCIDDREAM       : String = 'luciddream';
  ATTRIBUTE_LABEL1           : String = 'label1';
  ATTRIBUTE_ASTRALPROJECTION : String = 'astralprojection';
  ATTRIBUTE_LABEL2           : String = 'label2';
  ATTRIBUTE_OUTOFBODY        : String = 'outofbody';
  ATTRIBUTE_LABEL3           : String = 'label3';
  ATTRIBUTE_OTHEREXPERIENCE  : String = 'otherexperience';
  ATTRIBUTE_LABEL4           : String = 'label4';
  ATTRIBUTE_READONLY         : String = 'readonly';
  ATTRIBUTE_CAPTION          : String = 'caption';
  ATTRIBUTE_LEVEL            : String = 'level';
  ATTRIBUTE_LEFT             : String = 'left';
  ATTRIBUTE_TOP              : String = 'top';
  ATTRIBUTE_WIDTH            : String = 'width';
  ATTRIBUTE_HEIGHT           : String = 'height';
  ATTRIBUTE_TREE_WIDTH       : String = 'treewidth';
  ATTRIBUTE_USER_NAME        : String = 'username';
  ATTRIBUTE_USER_PASSWORD    : String = 'userpassword';
  ATTRIBUTE_CONFIRMDELETE    : String = 'confirmdelete';
  ATTRIBUTE_DEFAULT          : String = 'default';
  ATTRIBUTE_EXPERIENCEVIEW   : String = 'experienceview';
  ATTRIBUTE_HEADER           : String = 'header';
  ATTRIBUTE_FOOTER           : String = 'footer';
  ATTRIBUTE_TYPE             : String = 'type';
  ATTRIBUTE_FILE             : String = 'file';
  ATTRIBUTE_NICK             : String = 'nick';
  ATTRIBUTE_EMAIL            : String = 'email';
  ATTRIBUTE_SEX              : String = 'sex';
  ATTRIBUTE_AGE              : String = 'age';
  ATTRIBUTE_DICTIONARY       : String = 'dictionary';
  ATTRIBUTE_VOCABULARY       : String = 'vocabulary';
  ATTRIBUTE_CONTROL          : String = 'control';
  ATTRIBUTE_VALUE            : String = 'value';

resourcestring
  LABEL_NAME                       = ':';
  LABEL_PATH                       = ':';
  LABEL_DATE                       = ':';
  LABEL_NUMBER                     = '';
  CAPTION_LIBRARY                  = ' ';
  CAPTION_CATALOGUE                = ' ';
  CAPTION_FILE                     = ' ';
  CAPTION_DAY                      = ' ';
  CAPTION_EXPERIENCE               = ' ';
  CAPTION_AUTHORIZATION            = '';
  CAPTION_AUTHORIZATION_PARAMETERS = ' ';
  CAPTION_OPEN_IMAGE               = ' ';
  CAPTION_OPEN_LIBRARY             = ' ';
  CAPTION_SAVE_LIBRARY             = '  ';
  CAPTION_EXPORT                   = '';
  HINT_CURRENT_DATE                = ' ';
  HINT_NEXT_NUMBER                 = ' ';
  HINT_OPEN_FILE                   = '  ';
  QUESTION_DELETE_PART_1           = '     "';
  QUESTION_DELETE_PART_2           = '" ?';
  GRAPH_HEADER_MONTH_1             = '   ';
  GRAPH_HEADER_MONTH_2             = ' ';
  GRAPH_HEADER_DAY_1               = ' ';
  GRAPH_FOOTER_MONTH_2             = ' : ';
  GRAPH_FOOTER_DAY_1               = '   : ';
  GRAPH_HEADER_YEAR_1              = '    ';
  GRAPH_HEADER_YEAR_2              = '    ';
  GRAPH_HEADER_YEAR_3_PART_1       = '   : [';
  GRAPH_HEADER_YEAR_3_PART_2       = ']';
  GRAPH_FOOTER_YEAR_1              = ' : ';
  GRAPH_FOOTER_YEAR_2              = '     : ';
  GRAPH_FOOTER_YEAR_3              = '   : ';
  XML_ENCODING                     = 'windows-1251';
  FILTER_IMAGE                     = 'Windows BMP (*.bmp)|*.bmp|  (*.*)|*.*';
  FILTER_JOURNAL                   = '  (*.xml)|*.xml|  (*.*)|*.*';
  FILTER_LIBRARY                   = '  (*.xml)|*.xml|  (*.*)|*.*';
  FILTER_EXTERNAL_FILE             = '  (*.xml)|*.xml|  (*.*)|*.*';
  FILTER_EXPORT                    = ' (*.html)|*.html|  (*.txt)|*.txt';

//-[ IMPLEMENTATION ]----------------------------------------------------------
implementation

//-[ END ]---------------------------------------------------------------------
end.
